local TSM = select(2, ...)
local Sort = TSM:NewModule("Sort")
local Util = TSM:GetModule("Util")
local Moves, bagState = {}, {}
TSM.SortBank = false

function TSM:GUILDBANKFRAME_OPENED()
	if not TSM.SortToGBankButton or not TSM.SortGBankButton then
		if (BagnonFrameguildbank and BagnonFrameguildbank:IsShown()) then  -- Bagnon Handling
			--print("Bagnon detected")
			self.SortToGBankButton = CreateFrame("Button","SortToGBank",BagnonFrameguildbank,"GameMenuButtonTemplate")
			self.SortToGBankButton:SetPoint("BOTTOMRIGHT", -190, 5)
			self.SortToGBankButton:SetWidth(110)
			self.SortToGBankButton:SetText("Sort To Guild")
			self.SortToGBankButton:SetScript("OnClick", function()
				self.SortToGBankButton:Disable()
				Sort:StartGbankPut()
			end
			)
			
			self.SortGBankButton = CreateFrame("Button","SortGBank", BagnonFrameguildbank,"GameMenuButtonTemplate")
			self.SortGBankButton:SetPoint("BOTTOMRIGHT", -300, 5)
			self.SortGBankButton:SetWidth(110)
			self.SortGBankButton:SetText("Sort Guild")
			self.SortGBankButton:SetScript("OnClick", function()
				self.SortGBankButton:Disable()
				Sort:StartGbankSort()
			end
			)
		else
			--print("Default GBank")
			self.SortToGBankButton = CreateFrame("Button","SortToGBank", GuildBankFrame,"GameMenuButtonTemplate")
			self.SortToGBankButton:SetPoint("BOTTOMRIGHT", -510, 30)
			self.SortToGBankButton:SetWidth(110)
			self.SortToGBankButton:SetText("Sort To Guild")
			self.SortToGBankButton:SetScript("OnClick", function()
				self.SortToGBankButton:Disable()
				Sort:StartGbankPut()
			end
			)
			
			self.SortGBankButton = CreateFrame("Button","SortGBank", GuildBankFrame,"GameMenuButtonTemplate")
			self.SortGBankButton:SetPoint("BOTTOMRIGHT", -630, 30)
			self.SortGBankButton:SetWidth(110)
			self.SortGBankButton:SetText("Sort Guild")
			self.SortGBankButton:SetScript("OnClick", function()
				self.SortGBankButton:Disable()
				Sort:StartGbankSort()
			end
			)
		end
	else
		TSM.SortGBankButton:Show()
		TSM.SortToGBankButton:Show()
	end
end

local function getBagSlots()
	local t = {}
	for i = 1, NUM_BAG_SLOTS + 1 do
		t[i] = i - 1
	end
	return t
end

function Sort:StartGbankSort()
	if (GuildBankFrame and GuildBankFrame:IsShown()) then
		TSM.SortBank = true
		TSM:Print("Starting")
		Sort:GenerateMoves()
		TSMAPI:CreateTimeDelay("RunSort",0.5,Sort.RunSort,0.75)
	else
		TSM:Print("Must be at guildbank")
	end
end

function Sort:StartGbankPut()
	if (GuildBankFrame and GuildBankFrame:IsShown()) then
		TSM:Print("Starting")
		Sort:GenerateMoves()
		TSMAPI:CreateTimeDelay("RunSort",0.5,Sort.RunSort,0.4)
	else
		TSM:Print("Must be at guildbank")
	end
end

function Sort:GenerateMoves()
	if TSM.PlayerGuild == nil then
		TSM.PlayerGuild = select(1,GetGuildInfo("player"))
	end
	
	wipe(Moves)
	if TSM.SortBank == false then
		for i, bag in ipairs(getBagSlots()) do
			for slot = 1, GetContainerNumSlots(bag) do
				local Item = GetContainerItemID(bag,slot)
				local Guild,Tab = Util:CheckTabAndGuild(Item)
				if Tab == nil or Guild == nil then
					--print("Nil"..bag..slot)
				else
					if TSM.PlayerGuild == Guild then
						tinsert(Moves,{Src = "bags", DestTab = Tab, SrcBag = bag, SrcSlot = slot})
					else
						TSM:Print(Guild.." not equal to "..TSM.PlayerGuild)
					end
				end
			end
		end
	else
		for i, bag in ipairs(getBagSlots()) do
			for slot = 1, GetContainerNumSlots(bag) do
				local Item = GetContainerItemID(bag,slot)
				local Guild,Tab = Util:CheckTabAndGuild(Item)
				if Tab == nil or Guild == nil then
					--print("Nil"..bag..slot)
				else
					if TSM.PlayerGuild == Guild then
						tinsert(Moves,{Src = "bags", DestTab = Tab, SrcBag = bag, SrcSlot = slot})
					else
						TSM:Print(Guild.." not equal to "..TSM.PlayerGuild)
					end
				end
			end
		end
		for cTab=1,GetNumGuildBankTabs(),1  do
			for slot = 1, 98,1 do
				local Item = GetGuildBankItemLink(cTab,slot)
				local Guild,Tab = Util:CheckTabAndGuild(Item)
				if Tab == nil or Guild == nil then
					--print("Nil"..bag..slot)
				elseif cTab == Tab then
					-- nothing
				else
					if TSM.PlayerGuild == Guild then
						tinsert(Moves,{Src = "guildbank", SrcTab = cTab,  SrcSlot = slot, DestTab = Tab})
					else
						TSM:Print(Guild.." not equal to "..TSM.PlayerGuild)
					end
				end
			end
		end
	end
end

function Sort.RunSort()
	if #Moves > 0 then
		local i = next(Moves)
		local Src = Moves[i].Src
		
		if Src == "guildbank" then
			local DestTab = Moves[i].DestTab
			local SrcTab = Moves[i].SrcTab
			local SrcSlot = Moves[i].SrcSlot
			--print(format("%d, %d, %d",SrcTab, SrcSlot, DestTab))
			if SrcTab ~= nil and SrcSlot ~= nil and DestTab ~= nil then
				SetCurrentGuildBankTab(SrcTab)
				AutoStoreGuildBankItem(SrcTab, SrcSlot)
			end
			tremove(Moves, i)
			Sort:GenerateMoves()
		
		elseif Src == "bags" then
			local SrcBag = Moves[i].SrcBag
			local SrcSlot = Moves[i].SrcSlot
			local DestTab = Moves[i].DestTab
			--print(format("%d, %d, %d",SrcBag, SrcSlot, DestTab))
			if SrcBag ~= nil and SrcSlot ~= nil and DestTab ~= nil then
				SetCurrentGuildBankTab(DestTab)
				UseContainerItem(SrcBag, SrcSlot)
			end
			tremove(Moves, i)
			Sort:GenerateMoves()
		end
	else
		TSMAPI:CancelFrame("RunSort")
		TSM:Print("Finished")
		TSM.SortBank = false
		TSM.SortGBankButton:Enable()
		TSM.SortToGBankButton:Enable()
	end
end